#ifdef BGE_COCONUT
#include "shaders/common/postfx/hdr/ACES.h.hlsl"
#endif

// http://de.slideshare.net/ozlael/hable-john-uncharted2-hdr-lighting
float3 TonemapOperatorUncharted2(float3 x)
{
    x *= .6f;
    float a = 2.93f; //toeStrength
    float b = 0.15f; //toeLength
    float c = 2.53f; //shoulderStrength
    float d = 0.99f; //shoulderLength
    float e = 0.54f; //shoulderAngle
    return clamp((x*(a*x+b))/(x*(c*x+d)+e), 0.0f, 1.0f);
}

float3 TonemapUncharted2(float3 color)
{
    const float exposure_adjustment = 1; //16;  //AL values
    const float exposure_bias = 1; //2;

    color = max(color, 0) * exposure_adjustment;
    const float whiteScale = (1.0f / TonemapOperatorUncharted2(11.2f)).x;
    return saturate(TonemapOperatorUncharted2(exposure_bias * color) * whiteScale);
}

float3 tonemap(float3 rgb) {
#ifdef BGE_COCONUT
    return toLinearColor(ACESFitted(linearToGammaColor(rgb)));
#else
   return TonemapUncharted2(rgb);
#endif
}